using System;
using SigKnockOpener;
using System.Xml;
using System.Xml.Serialization;

namespace SigKnockClient
{
	/// <summary>
	/// Summary description for SessionContainer.
	/// </summary>
	public class SessionContainer
	{
		[XmlElement("host")] public string host;
		[XmlElement("port")] public string port;
		[XmlIgnore] public SigKnockOpener.UserIDKeyIDTupel userid;

		public SessionContainer()
		{
			userid=new UserIDKeyIDTupel("", "");
		}

		public override string ToString()
		{
			return host;
		}

		[XmlElement("uid")]
		public String uid
		{
			get
			{
				return userid.uid;
			}
			set
			{
				if(value==null)
					return;
				userid.uid=value;
			}
		}

		[XmlElement("keyid")]
		public String keyid
		{
			get
			{
				return userid.keyid;
			}
			set
			{
				if(value==null)
					return;
				userid.keyid=value;
			}
		}
	}
}
