using System;
using System.Collections;

namespace SigKnockOpener
{
	/// <summary>
	/// Abstract class that defines the interface for OS-independence.
	/// On Win32 we use PGP via a COM-Class.
	/// </summary>
	public abstract class SigKnockSignHelper
	{
		public SigKnockSignHelper()
		{
			
		}

		/// <summary>
		/// Sign the challenge with the User-ID. The particular implementation
		/// has to get the passphrase itself.
		/// </summary>
		/// <param name="challenge">The challenge to be signed</param>
		/// <param name="UID">User-ID to sign with</param>
		/// <returns>The detached signature</returns>
		public abstract byte[] sign(byte[] challenge, String UID);

		/// <summary>
		/// Gets the key candidates that are usable for signing
		/// </summary>
		/// <returns>The Key-IDs as ArrayList</returns>
		public abstract ArrayList getKeyIDs();
	}
}
