/************************************************************
 * libipt_SIGKNOCK-KEYPORT.c
 *
 * Userspace-iptables-interface to sigknock.
 *
 * Author: Thomas Wana <thomas@wana.at>
 *
 * $Id: libipt_SIGKNOCK-KEYPORT.c 114 2004-08-27 10:53:42Z greuff $
 *
 ************************************************************/


#include <stdio.h>
#include <netdb.h>
#include <string.h>
#include <stdlib.h>
#include <getopt.h>
#if defined(__GLIBC__) && __GLIBC__ == 2
#include <net/ethernet.h>
#else
#include <linux/if_ether.h>
#endif
#define __user
#include <iptables.h>
#include <linux/netfilter_ipv4/ipt_sigknock.h>

#include "../config.h"

int cmdlineflags;

static struct option opts_target[]={{0}};

/* Function which prints out a usage message. */
// TODO fix
static void help_target(void)
{
	printf(
"Signature knocking v%s options:\n"
" --keyport portnumber\n"
"			   Portnumber of the keyport (challenge handling)\n"
" --uid User-ID\n"
"			   User-ID of the signature to check against\n"
" --timeout Timeout[smhd]\n"
"			   Timeout (in seconds, minutes, hours or days) after the port closes again\n"
" --close-after-syn\n"
"			   Close the target after the first TCP-SYN came through\n"
"timeout and close-after-syn are exclusive.\n"
"Note: you *must* have a SIGKNOCK-KEYPORT target in your fw-rules; see\n"
"the sigknock docs for details.\n"
"\n", SIGKNOCK_VERSION);
}

/* Initialize the target. */
static void init_target(struct ipt_entry_target *m, unsigned int *nfcache)
{
	/* Can't cache this */
	*nfcache |= NFC_UNKNOWN;

   cmdlineflags=0;
}

/* Function which parses command options; returns true if it
   ate an option */
static int parse_target(int c, char **argv, int invert, unsigned int *flags,
      const struct ipt_entry *entry,
      struct ipt_entry_target **target)
{
   return 0;
}

/* Final check; all mandatory parameters have to be given */
static void final_check_target(unsigned int flags)
{
}

/* Prints the target. */
static void print_target(const struct ipt_ip *ip,
      const struct ipt_entry_target *target,
      int numeric)
{
   printf("SIGKNOCK-KEYPORT ");
}

/* Saves the target in parseable form to stdout. */
static void save_target(const struct ipt_ip *ip, const struct ipt_entry_target *target)
{
   //printf("SIGKNOCK-KEYPORT ");
}

static struct iptables_target sigknock_target = { 
    .next=NULL,
    .name="SIGKNOCK-KEYPORT",
    .version=NETFILTER_VERSION,
    .size=IPT_ALIGN(4),
    .userspacesize=IPT_ALIGN(4),
    .help=&help_target,
    .init=&init_target,
    .parse=&parse_target,
    .final_check=&final_check_target,
    .print=&print_target,
    .save=&save_target,
    .extra_opts=opts_target,
};

void _init(void)
{
   register_target(&sigknock_target);
}
