#ifndef _IPT_PK_H
#define _IPT_PK_H

// the match info that the kernel and the userspace iptables
// uses
struct ipt_sigknock_info {
    int timeout;          // --timeout: Timeout after the port closes again
    char timeout_char;    // Timeout factor (s, m, h, d)
    char uid[10][50];     // --uid: the signature UID(s)
    unsigned short uid_count;      // how many UIDs are used in 'uid'
    int close_after_syn;  // --close-after-syn: close the match after the 1st 
                          //                    connection is established?

    char id[10];          // unique identification of this rule, will be filled
                          // with random bytes upon rule creation, so the kernel
                          // module can find the right entry when created or
                          // deleted. For internal use only, will never be exposed
                          // to the user.
};

// Protocol states
enum e_proto { COOKIE_REQUEST, COOKIE_RESPONSE, CHALLENGE_REQUEST, CHALLENGE_RESPONSE,
               SIGNATURE_REQUEST, SIGNATURE_RESPONSE };

#endif /*_IPT_PK_H*/
